//#include <windows.h>
#include <D3d8.h>
#include <D3dx8math.h>

struct CUSTOMVERTEX
{
    FLOAT	x, y, z; // The 3-D position for the vertex.
    FLOAT	nx, ny, nz;   // The surface normal for the vertex.
//	DWORD color;        // The vertex color.
	FLOAT       tu, tv;   // The texture coordinates
};

// Custom FVF.
//#define D3DFVF_CUSTOMVERTEX (D3DFVF_XYZ|D3DFVF_NORMAL|D3DFVF_DIFFUSE|D3DFVF_TEX1)
#define D3DFVF_CUSTOMVERTEX (D3DFVF_XYZ|D3DFVF_NORMAL|D3DFVF_TEX1)


IDirect3D8*			g_pD3D			= NULL;
IDirect3DDevice8*	g_pd3dDevice	= NULL;
LPDIRECT3DVERTEXBUFFER8 g_pVB       = NULL; // Buffer to hold vertices
LPDIRECT3DTEXTURE8	g_pTexture		= NULL;
LPDIRECT3DTEXTURE8	g_pTexture2		= NULL;

/*
void SetupLights()
{
	D3DMATERIAL8 mtrl;
    ZeroMemory( &mtrl, sizeof(D3DMATERIAL8) );
    mtrl.Ambient.r = 0.2f;
    mtrl.Ambient.g = 0.2f;
    mtrl.Ambient.b = 0.2f;
    mtrl.Ambient.a = 0.2f;
    g_pd3dDevice->SetMaterial( &mtrl );

		// Set up a light
	D3DXVECTOR3 vecDir;
	D3DLIGHT8 light;
	ZeroMemory( &light, sizeof(D3DLIGHT8) );
	light.Type       = D3DLIGHT_DIRECTIONAL;
	light.Diffuse.r  = 1.0f;
	light.Diffuse.g  = 1.0f;
	light.Diffuse.b  = 1.0f;

	vecDir = D3DXVECTOR3(0,0,1);
	D3DXVec3Normalize( (D3DXVECTOR3*)&light.Direction, &vecDir );
	light.Range       = 1000.0f;

	g_pd3dDevice->SetLight( 0, &light );

	g_pd3dDevice->LightEnable( 0, TRUE);

	g_pd3dDevice->SetRenderState( D3DRS_LIGHTING, TRUE );

	g_pd3dDevice->SetRenderState( D3DRS_AMBIENT, 0x00ffffff );
}
*/

//-----------------------------------------------------------------------------
// Name: SetupMatrices()
// Desc: Sets up the world, view, and projection transform matrices.
//-----------------------------------------------------------------------------
VOID SetupMatrices()
{
    // For our world matrix, we will just leave it as the identity
    D3DXMATRIX matWorld;
    D3DXMatrixIdentity( &matWorld );
 //   D3DXMatrixRotationX( &matWorld, timeGetTime()/1000.0f );
    g_pd3dDevice->SetTransform( D3DTS_WORLD, &matWorld );

    // Set up our view matrix. A view matrix can be defined given an eye point,
    // a point to lookat, and a direction for which way is up. Here, we set the
    // eye five units back along the z-axis and up three units, look at the
    // origin, and define "up" to be in the y-direction.
    D3DXMATRIX matView;
    D3DXMatrixLookAtLH( &matView, &D3DXVECTOR3( 0.0f, 0.0f, 5.0f ),
                                  &D3DXVECTOR3( 0.0f, 0.0f, 0.0f ),
                                  &D3DXVECTOR3( 0.0f, -1.0f, 0.0f ) );
    g_pd3dDevice->SetTransform( D3DTS_VIEW, &matView );

    // For the projection matrix, we set up a perspective transform (which
    // transforms geometry from 3D view space to 2D viewport space, with
    // a perspective divide making objects smaller in the distance). To build
    // a perpsective transform, we need the field of view (1/4 pi is common),
    // the aspect ratio, and the near and far clipping planes (which define at
    // what distances geometry should be no longer be rendered).
    D3DXMATRIX matProj;
//    D3DXMatrixPerspectiveFovLH( &matProj, D3DX_PI/4, 1.0f, 1.0f, 100.0f );
	D3DXMatrixOrthoLH( &matProj, 4, 4, -10, 10);
    g_pd3dDevice->SetTransform( D3DTS_PROJECTION, &matProj );
}

CUSTOMVERTEX g_Vertices[] =
{
    { 1.0f,  0.0f, 0.0f, 0,0,1, 1,0, }, // x, y, z, normal, color, tex
    { 1.0f,  1.0f, 0.0f, 0,0,1, 1,1, },
    { 0.0f,  0.0f, 0.0f, 0,0,1, 0,0, },
	{ 0.0f,  1.0f, 0.0f, 0,0,1, 0,1, },
//    { 0.0f,  1.0f, 0.0f, 0,0,1, 0xffffffff, 0,1, },
};


HRESULT initializeGeometry()
{
	if( FAILED( D3DXCreateTextureFromFile( g_pd3dDevice, "Image3.tga",
                                       &g_pTexture ) ) )
	{
		return E_FAIL;
	}

	if( FAILED( D3DXCreateTextureFromFile( g_pd3dDevice, "Servo.jpg",
                                       &g_pTexture2 ) ) )
	{
		return E_FAIL;
	}

	if( FAILED( g_pd3dDevice->CreateVertexBuffer( 3*sizeof(CUSTOMVERTEX),
                                              0, D3DFVF_CUSTOMVERTEX,
                                              D3DPOOL_DEFAULT, &g_pVB ) ) )
	{
		return E_FAIL;
	}

	CUSTOMVERTEX* pVertices;
	if( FAILED( g_pVB->Lock( 0, sizeof(g_Vertices), (BYTE**)&pVertices, 0 ) ) )
		return E_FAIL;
	memcpy( pVertices, g_Vertices, sizeof(g_Vertices) );

/*
	// Create a triangle
	pVertices[0].position = D3DXVECTOR3(-1.0f,-1.0f, 0.0f);
	pVertices[1].position = D3DXVECTOR3(1.0f,-1.0f, 0.0f);
	pVertices[2].position = D3DXVECTOR3(0.0f,1.0f, 0.0f);

	pVertices[0].normal = D3DXVECTOR3(0.0f, 0.0f, -1.0f);
	pVertices[1].normal = D3DXVECTOR3(0.0f, 0.0f, -1.0f);
	pVertices[2].normal = D3DXVECTOR3(0.0f, 0.0f, -1.0f);

	pVertices[0].color = 0xffff0000;
	pVertices[1].color = 0xff00ff00;
	pVertices[2].color = 0xff00ffff;
*/
	g_pVB->Unlock();

	return S_OK;
}

//-----------------------------------------------------------------------------
// Name: Render()
// Desc: Draws the scene
//-----------------------------------------------------------------------------
VOID Render()
{
    if( NULL == g_pd3dDevice )
        return;



    // Clear the backbuffer to a blue color
    g_pd3dDevice->Clear( 0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER, D3DCOLOR_XRGB(0,0,255), 1.0f, 0 );


    // Begin the scene
    g_pd3dDevice->BeginScene();
    // Rendering of scene objects can happen here

//	SetupLights();
	SetupMatrices();

	 // Setup our texture. Using textures introduces the texture stage states,
    // which govern how textures get blended together (in the case of multiple
    // textures) and lighting information. In this case, we are modulating
    // (blending) our texture with the diffuse color of the vertices.
    g_pd3dDevice->SetTexture( 0, g_pTexture );
	/*
    g_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_MODULATE );
    g_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
    g_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );
	g_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP,   D3DTOP_BLENDTEXTUREALPHA );
*/
    g_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_SELECTARG1 );
    g_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
    g_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP,   D3DTOP_SELECTARG1 );
    g_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE );
    g_pd3dDevice->SetTextureStageState( 0, D3DTSS_MINFILTER, D3DTEXF_LINEAR );
    g_pd3dDevice->SetTextureStageState( 0, D3DTSS_MAGFILTER, D3DTEXF_LINEAR );
    g_pd3dDevice->SetTextureStageState( 0, D3DTSS_ADDRESSU,  D3DTADDRESS_CLAMP );
    g_pd3dDevice->SetTextureStageState( 0, D3DTSS_ADDRESSV,  D3DTADDRESS_CLAMP );

 
    g_pd3dDevice->SetStreamSource( 0, g_pVB, sizeof(CUSTOMVERTEX) );
	g_pd3dDevice->SetVertexShader( D3DFVF_CUSTOMVERTEX );

	
    D3DXMATRIX matWorld;
    D3DXMatrixRotationZ( &matWorld, timeGetTime()/1000.0f );
    g_pd3dDevice->SetTransform( D3DTS_WORLD, &matWorld );

    g_pd3dDevice->SetTexture( 0, g_pTexture2 );
	g_pd3dDevice->DrawPrimitive( D3DPT_TRIANGLESTRIP, 0, 2 );


    D3DXMatrixScaling( &matWorld, 2, 2, 2 );
    g_pd3dDevice->SetTransform( D3DTS_WORLD, &matWorld );

    g_pd3dDevice->SetTexture( 0, g_pTexture );
	g_pd3dDevice->DrawPrimitive( D3DPT_TRIANGLESTRIP, 0, 2 );


    ////////////////////////////////////////////////////////////////
	// End the scene
    g_pd3dDevice->EndScene();
    
    // Present the backbuffer contents to the display
    g_pd3dDevice->Present( NULL, NULL, NULL, NULL );
}

LRESULT WINAPI WndProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
    switch( msg )
    {
        case WM_DESTROY:
            PostQuitMessage( 0 );
            return 0;
    }

    return DefWindowProc( hWnd, msg, wParam, lParam );
}

HRESULT initialize_D3D(HWND hWnd)
{
   // Create the D3D object.
    if( NULL == ( g_pD3D = Direct3DCreate8( D3D_SDK_VERSION ) ) )
        return E_FAIL;

    // Get the current desktop display mode, so we can set up a back
    // buffer of the same format
    D3DDISPLAYMODE d3ddm;
    if( FAILED( g_pD3D->GetAdapterDisplayMode( D3DADAPTER_DEFAULT, &d3ddm ) ) )
        return E_FAIL;

    // Set up the structure used to create the D3DDevice. Since we are now
    // using more complex geometry, we will create a device with a zbuffer.
    D3DPRESENT_PARAMETERS d3dpp;
    ZeroMemory( &d3dpp, sizeof(d3dpp) );
    d3dpp.Windowed = TRUE;
    d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
    d3dpp.BackBufferFormat = d3ddm.Format;
    d3dpp.EnableAutoDepthStencil = TRUE;
    d3dpp.AutoDepthStencilFormat = D3DFMT_D16;

    // Create the D3DDevice
    if( FAILED( g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
                                      D3DCREATE_SOFTWARE_VERTEXPROCESSING,
                                      &d3dpp, &g_pd3dDevice ) ) )
    {
        return E_FAIL;
    }

    // Turn off culling
    g_pd3dDevice->SetRenderState( D3DRS_CULLMODE, D3DCULL_NONE );

    // Turn off D3D lighting
    g_pd3dDevice->SetRenderState( D3DRS_LIGHTING, FALSE );

    // Turn on the zbuffer
    g_pd3dDevice->SetRenderState( D3DRS_ZENABLE, TRUE );

   // Set diffuse blending for alpha set in vertices.
    g_pd3dDevice->SetRenderState( D3DRS_ALPHABLENDENABLE,   TRUE );
    g_pd3dDevice->SetRenderState( D3DRS_SRCBLEND,  D3DBLEND_SRCALPHA );
    g_pd3dDevice->SetRenderState( D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA );
        g_pd3dDevice->SetRenderState( D3DRS_ALPHATESTENABLE, TRUE );
        g_pd3dDevice->SetRenderState( D3DRS_ALPHAREF,        0x08 );
        g_pd3dDevice->SetRenderState( D3DRS_ALPHAFUNC, D3DCMP_GREATEREQUAL );


    return S_OK;
}

VOID Cleanup_D3D()
{
    if( g_pTexture != NULL )
	{
        g_pTexture->Release();
		g_pTexture = NULL;
	}


    if( g_pTexture2 != NULL )
	{
        g_pTexture2->Release();
		g_pTexture2 = NULL;
	}

    if( g_pVB != NULL )
	{
        g_pVB->Release();
		g_pVB = NULL;
	}

    if( g_pd3dDevice != NULL )
	{
        g_pd3dDevice->Release();
		g_pd3dDevice = NULL;
	}

    if( g_pD3D != NULL )
	{
        g_pD3D->Release();
		g_pD3D = NULL;
	}
}

INT WINAPI WinMain( HINSTANCE hInst, HINSTANCE, LPSTR, int nCmdShow)
{
	MSG msg;

    // Register the window class.
    WNDCLASSEX wc = { sizeof(WNDCLASSEX), CS_CLASSDC, WndProc, 0L, 0L, 
                      GetModuleHandle(NULL), NULL, NULL, NULL, NULL,
                      "D3D Tutorial", NULL };
    RegisterClassEx( &wc );

    // Create the application's window.
    HWND hWnd = CreateWindow( "D3D Tutorial", "D3D Tutorial 01: CreateDevice", 
                              WS_OVERLAPPEDWINDOW, 50, 50, 200, 200,
                              GetDesktopWindow(), NULL, wc.hInstance, NULL );


    // Initialize Direct3D
    if( SUCCEEDED(initialize_D3D(hWnd)) )
    {
		// Create the scene geometry
        if( SUCCEEDED( initializeGeometry() ) )
        {
			// Show the window
			ShowWindow( hWnd, SW_SHOWDEFAULT );

			// Enter the message loop
			ZeroMemory( &msg, sizeof(msg) );
			while( msg.message!=WM_QUIT )
			{
				if( PeekMessage( &msg, NULL, 0U, 0U, PM_REMOVE ) )
				{
					TranslateMessage( &msg );
					DispatchMessage( &msg );
				}
				else
					Render();
			}
		}
    }

    // Clean up everything and exit the app
    Cleanup_D3D();
    UnregisterClass( "D3D Tutorial", wc.hInstance );
	return 0;
}
